// Header File
// Created 3/18/2005; 4:50:35 PM
#ifndef _GRAY_I
#define _GRAY_I
extern short grayHandle;
extern void *D_plane,*D_plane2;
extern unsigned short gray_dbl_offset;
extern unsigned short GrayHwType;
extern volatile unsigned long GraySwitchCnt;

//code taken frome GrayOn and modified so it is inlined and uses consecutive planes and allocates all mem in one single block
extern inline void *GrayOn_inline(void){
	asm(
"	lea      (grayHandle,%%pc),%%a2            | if grayHandle is not 0\n"
"	tst.w    (%%a2)                              | we have already allocated\n"
"	bne.s    __gray_init_return                 | memory -> out here\n"
"    |--------------------------------------------------------------------------
    | HeapAllocHigh(HW1=3848 bytes or HW2=7688 bytes)
    |--------------------------------------------------------------------------\n"
"	pea	 0x3C08.w\n"
INLINE_ASM_ROM_CALL(0x92)//HeapAllocHigh
"	addq.w   #4,%%a7\n"
"	move.w   %%d0,(%%a2)+                   | store handle in handle variable\n"
"	beq.s    __gray_init_return           | alloc failed (handle=0) -> out here\n"
"	clr.w    (%%a2)                        | clears gray_dbl_offset\n"
"    |--------------------------------------------------------------------------
    | HeapDeref(grayHandle)
    |--------------------------------------------------------------------------\n"
"	move.w   %%d0,-(%%a7)\n"
INLINE_ASM_ROM_CALL(0x96)//HeapDeref
"	addq.l   #2,%%a7\n"
"    |--------------------------------------------------------------------------
    | align memory address to next 8-byte boundary and store address in
    | __gray_used_mem
    |
    | L_plane gets set to gray_used_mem + 0xf00
    |--------------------------------------------------------------------------\n"
"	move.l   %%a0,%%d0\n"
"	addq.l   #7,%%d0\n"
"	andi.b   #0xF8,%%d0\n"
"	lea      (gray_used_mem,%%pc),%%a0\n"
"	move.l   %%d0,(%%a0)\n"
"	move.l   %%d0,(D_plane - gray_used_mem,%%a0)\n"
"	add.l 	 #0x0F00,%%d0\n"
"	move.l   %%d0,(L_plane - gray_used_mem,%%a0)\n"
"	add.l 	 #0x0F00,%%d0\n"
"	move.l   %%d0,(D_plane2 - gray_used_mem,%%a0)\n"
"	add.l 	 #0x0F00,%%d0\n"
"	move.l   %%d0,(L_plane2 - gray_used_mem,%%a0)\n"
"__gray_init_return:":::"a0","a1","a2","d1","d2");
	if(!grayHandle)return NULL;
	void *rtaddr;
	asm(//__gray_init_handler
".ifdef ALWAYS_HW2_TESTING\n"
"	bra.s __always_hw2_proceed\n"
".endif\n"
/*"	move.l   0xc8,%%d0\n"
"	and.l    #0xE00000,%%d0          | get the ROM base\n"
"	move.l   %%d0,%0\n"*/
"	move.l   260(%0),%%a1           | get pointer to the hardware param block\n"
"	add.l    #0x10000,%0\n"
"	cmp.l    %0,%%a1                | check if the HW parameter block is near\n"
"	bcc.s    __gray_patches_for_hw1 | if it is too far, it is HW1\n"
"	cmp.w    #22,(%%a1)              | check if the parameter block contains HW\n"
"	bls.s    __gray_patches_for_hw1 | if it is too small, it is HW1\n"
"	cmp.l    #1,22(%%a1)             | check the hardware version\n"
"	beq.s    __gray_patches_for_hw1 | if not 1, it is HW2 (or an unknown HW)\n"
"    |--------------------------------------------------------------------------\n"
"    | check for VTI (trick suggested by Julien Muchembled)\n"
"    |--------------------------------------------------------------------------\n"
"	trap     #12         | enter supervisor mode. returns old (%%sr) in %%d0.w\n"
"	move.w   #0x3000,%%sr | set a non-existing flag in %%sr (but keep s-flag)\n"
"	swap     %%d0         | save %%d0.w content in upper part of %%d0\n"
"	move.w   %%sr,%%d0     | get %%sr content and check for non-existing flag\n"
"	btst     #12,%%d0     | this non-existing flag can only be set on the VTI\n"
"	seq.b    %%d1	     | flag not set set %%d1\n"
"	swap     %%d0         | restore old %%sr content\n"
"	move.w   %%d0,%%sr\n"
".ifdef ALWAYS_HW2_TESTING\n"
"__always_hw2_proceed:\n"
"	moveq #1,%%d1\n"
".endif\n"
"	lea      (__gray_int1_handler_hw2,%%pc),%0\n"
"	and.w	 #1,%%d1      |make %%d1 0x0000 or 0x0001\n"
"	bne.s	 __hw_store  |if 1 store hw vertion and return\n"
"    |--------------------------------------------------------------------------\n"
"    | HW1 detected\n"
"    |--------------------------------------------------------------------------\n"
"__gray_patches_for_hw1:\n"
"	clr.w   %%d1	      				|%%d1 may or may not be 0 so clear it\n"
"	lea      (__gray_int1_handler_hw1,%%pc),%0	|return __gray_int1_handler_hw1 in %0\n"
"__hw_store:\n"
"	lea	 (GrayHwType,%%pc),%%a1\n"
"	move.w   %%d1,(%%a1)":"=a"(rtaddr):"0"(ROM_base):"a1","d0","d1","d2");
	return rtaddr;
}

#endif